



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[译]Domain Events Pattern Example</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[译]Domain Events Pattern Example</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 14:13:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="http://www.tonytruong.net/domain-events-pattern-example/" rel="external nofollow noreferrer">原文</a></p>
<p><a href="https://github.com/maoyuan121/domaineventsexample" rel="external nofollow noreferrer">完整源码</a></p>
<p>本文展示的是一个关于网上调查的项目。想象下，当用户完成了一个调查，我们想通知所有人调查已经结束，分配一个人去检查调用问卷。</p>
<h2>领域对象</h2>
<pre class="prettyprint linenums"><code>public class Survey<br />
{<br />
    public Guid Id { get; private set; }<br />
    public DateTime EndTime { get; private set; }<br />
    public string QualityChecker { get; set; }

    public Survey()<br />
    {<br />
        this.Id = Guid.NewGuid();<br />
    }

    public void EndSurvey()<br />
    {<br />
        EndTime = DateTime.Now;<br />
        DomainEvent.Raise(new EndOfSurvey() { Survey = this });<br />
    }<br />
}<br />
</code></pre>
<p>这个领域对象非常简单，只有一个行为：<strong>EndSurvey()</strong>.</p>
<p>那么这里的<code>DomainEvent</code>是个什么东西呢？它是一个静态类，它发布了一个<code>EndOfSurvey</code>事件。从项目源码中可以看到所有的事件都放在名为<strong>Events</strong>的文件夹下面。领域对象放在<strong>Domain</strong>文件夹下面。</p>
<h2>EndOfSurvey事件</h2>
<p>现在Survey对象希望发布一个EndOfSurvey事件。这个事件的代码如下：</p>
<pre class="prettyprint linenums"><code>public class EndOfSurvey : IDomainEvent<br />
{<br />
    public Survey Survey { get; set; }<br />
}<br />
</code></pre>
<p><code>EndOfSurvey</code>包含一个<code>Survey</code>实例。它继承自<code>IDomainEvent</code>，这样我们知道他是一个领域事件。本例中所有的事件都要继承自<code>IDomainEvent</code>。<br /><br />
这个接口的定义很简单：</p>
<pre class="prettyprint linenums"><code>public interface IDomainEvent { }<br />
</code></pre>
<h2>DomainEvent类</h2>
<pre class="prettyprint linenums"><code>public static class DomainEvent<br />
{<br />
    public static IEventDispatcher Dispatcher { get; set; }

    public static void Raise&lt;T&gt;(T @event) where T : IDomainEvent<br />
    {<br />
        Dispatcher.Dispatch(@event);<br />
    }

}<br />
</code></pre>
<p>源码中的DomainEvent比这个要复杂点，但最重要的便是上面的代码了。</p>
<p><code>IEventDispatcher</code>是一个ioc容器。它负责找到正确的handler来处理<code>EndOfSurvey</code>事件。</p>
<pre class="prettyprint linenums"><code>public interface IEventDispatcher<br />
{<br />
    void Dispatch&lt;TEvent&gt;(TEvent eventToDispatch) where TEvent : IDomainEvent;<br />
}<br />
</code></pre>
<p>泛型方法<code>Raise&lt;T&gt;</code>能让我们发布无数的事件，<code>Dispatcher</code>自动找出对应的handler。</p>
<p>下面定义一个处理所有事件的handler接口：</p>
<pre class="prettyprint linenums"><code>public interface IDomainHandler&lt;T&gt; where T : IDomainEvent<br />
{<br />
    void Handle(T @event);<br />
}<br />
</code></pre>
<p>我将<strong>IEventDispatcher.cs</strong>和<strong>IDomainHandler.cs</strong>都放在一个名为<strong>Services</strong>的文件夹下面。其他的项目必须提供具体的实现。</p>
<p>domain程序集的代码就是这些了。</p>
<h2>定义domain事件handler</h2>
<p>我创建了另外一个项目用来写event handler。</p>
<p><code>EndOfSurveyHandler</code>用来处理<code>EndOfSurvey</code>事件：</p>
<pre class="prettyprint linenums"><code>public class EndOfSurveyHandler:IDomainHandler&lt;EndOfSurvey&gt;<br />
{<br />
    public void Handle(EndOfSurvey args)<br />
    {<br />
        args.Survey.QualityChecker = &quot;Ivan Amalo&quot;;<br />
        // 发送邮件给Ivan，通知他来检查调查问卷<br />
    }<br />
}<br />
</code></pre>
<p>如果想使用repository进行一些数据持续化的工作，或者使用一些其他的服务，可以将这些repository和服务通过构造函数注入进来。</p>
<p><code>EndOfSurveyHandler</code>和<code>EndOfSurvey</code>事件是怎么联系起来的呢？</p>
<h2>将所有的代码集成起来</h2>
<p>下面要讲<strong>Survey.FrontEnd</strong>是一个MVC + WebApi应用，这个应用将DomainEvent，Dispatcher，Handler都结合了起来。</p>
<p>这个项目依赖于<strong>Ninject.MVC3</strong>。</p>
<p>现在我们需要来实现在之前定义的<strong>IEventDispatcher</strong>。</p>
<pre class="prettyprint linenums"><code>public class NinjectEventContainer : IEventDispatcher<br />
{<br />
    private readonly IKernel _kernel;

    public NinjectEventContainer(IKernel kernel)<br />
    {<br />
        _kernel = kernel;<br />
    }

    public void Dispatch&lt;TEvent&gt;(TEvent eventToDispatch) where TEvent : IDomainEvent<br />
    {<br />
        foreach (var handler in _kernel.GetAll&lt;IDomainHandler&lt;TEvent&gt;&gt;())<br />
        {<br />
            handler.Handle(eventToDispatch);<br />
        }<br />
    }<br />
}<br />
</code></pre>
<p><code>Dispatch</code>方法使用kernel来查找所有实现了<code>IDomainHandler</code>的handler。在我们的例子中查找的是<code>EndOfSurveyHanlder</code>，然后执行它的<code>Handle()</code>方法。</p>
<p>在<strong>NinjectWebCommon.cs</strong>中我们定义了handler和event的对应关系。</p>
<pre class="prettyprint linenums"><code>private static void RegisterServices(IKernel kernel)<br />
{<br />
    DomainEvent.Dispatcher = new NinjectEventContainer(kernel);<br />
    kernel.Bind&lt;IDomainHandler&lt;EndOfSurvey&gt;&gt;().To&lt;EndOfSurveyHandler&gt;();<br />
}<br />
</code></pre>
<p>这就是我们将所有东西集成起来需要做的事情。</p>
<h2>测试</h2>
<p>我在<strong>EndOfSurveyHandler.cs</strong>中发布事件的代码那设置了一个断点，来测试事件已经发布，其对应的handler也被执行。</p>
<p>控制器的代码非常简单，如下：</p>
<pre class="prettyprint linenums"><code>public ActionResult Index()<br />
{<br />
    var survey = new Core.Domain.Survey();<br />
    survey.EndSurvey();

    return View(survey);<br />
}<br />
</code></pre>
<p>执行这个action，  Ivan Amalo应该被分配成为这个调查问卷的检查者，并且将EndDate设为当前时间。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r5v4q0.html">ASP&period;NET加密和解密数据库连接字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/390vr7j8.html">django ftp 研究</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7mjdeq.html">Objective-c快速入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1z0z09.html">YII2-数据库数据查询方法，关联查询with， joinWith区别和分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pppek9.html">Android原生json和fastjson的简单使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gzll08.html">Atitit paip&period;对象方法的实现原理与本质&period;txt</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8oepp19.html">Hadoop 2&period;4&period;1 登录认证配置小结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1p2459.html">Android开发指南-框架主题-安全和许可</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd7gny8.html">BZOJ 1192 鬼谷子的钱袋</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mem0o0q.html">JQuery遍历json数组的3种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1v7w1q.html">指尖上的电商---&lpar;12&rpar;SolrAdmin中加入多核的还有一种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv10lgjq.html">Android Studio 安装后首次启动的 Config path &period;&period;&period;&period;&period;&period; is invalid 问题&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1n321q.html">Thrift之TProtocol系列TBinaryProtocol解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mn4xm8.html">linux下的framebuffer显示图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zowmkvq.html">Kindle复活记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkp1nz8.html">Spark RDD持久化、广播变量和累加器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvk2p38.html">use this method get wifi from notebook</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r2p7m9.html">JAVA多线程的问题以及处理（二）【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj7zo59.html">hdu3336 Count the string 扩展KMP</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25ovelq.html">第二章&amp;&num;160&semi;向量（d1）有序向量：唯一化</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnvd3228.html">在linux环境下搭建JDK&plus;JAVA&plus;Mysql，并完成jforum的安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllnenkq.html">由AC自动机引发的灵感</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllnjeeq.html">latex 导入pdf</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdoknj9.html">vcf文件去除非变异的基因型（use GATK exclude nonvariant in vcf format&comma;0&vert;0&comma;0&sol;0）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdokve9.html">你真的知道什么是【共享Session】，什么是【单点登录】吗？</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1v1vpq.html">The CLI moved into a separate package&colon; webpack-cli&period;解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv5opy8.html">转：值得收藏！那些鲜为人知的 Mac OS X 技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rjdwj9.html">bzoj2434 fail树 &plus; dfs序 &plus; 树状数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdoomd9.html">剑指Offer&lowbar;编程题&lowbar;13</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rpj358.html">Hadoop HDFS常用操作命令</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
